/*///

    IndicatorOptimizer.mq4 
  
         
    
    Copyright  2009,  ,  http://forextools.com.ua

/*///
#property copyright "Copyright  2006-2009, Sergey Kravchuk. http://forextools.com.ua"
#property link      "http://forextools.com.ua"

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_level1 0

//    
extern bool   ShowZZ          = true;           //   
extern bool   ShowMARKERS     = false;           //    -
extern int    ProfitWidth     = 1;
extern bool   ProfitInPoints  = true;

//  
extern datetime DateStart     = D'1.01.1970';
extern datetime DateEnd       = D'31.12.2037';

//  
extern double LotForCalc      = 0.05;           //     

//   RSI
extern int    RSIPeriod       = 8;              //    RSI
extern int    RSILevel        = 73;             //    RSI

//   MA
extern int    MAPeriod        = 20;             //    
extern int    MAMode          = 3;              // 0-MODE_SMA 1-MODE_EMA 2-MODE_SMMA 3-MODE_LWMA
extern int    MAPrice         = 6;              // 0-Close 1-Open 2-High 3-Low 4-(H+L)/2 5-(H+L+C)/3 6-(H+L+2*C)/4


//   MACD
extern double MACDOpenLevel   = 3;              
extern double MACDCloseLevel  = 2;
extern double MATrendPeriod   = 26;

//   
extern color  ColorProfitBuy  = Blue;           //     
extern color  ColorLossBuy    = Red;            //     
extern color  ColorZeroBuy    = Gray;           //       

//   
extern color  ColorProfitSell = Blue;           //     
extern color  ColorLossSell   = Red;            //     
extern color  ColorZeroSell   = Gray;           //       

//   
extern color  ColorBuy        = CornflowerBlue; //     
extern color  ColorSell       = HotPink;        //     
extern color  ColorClose      = Gainsboro;      //     

//
double sBuy[],sCloseBuy[],sSell[],sCloseSell[]; //   
int sBuyCnt,sSellCnt,sBuyCloseCnt,sSellCloseCnt;//   
int i,DisplayBars;
double bBallance[]; //    
int IndicatorWindowNo;  //   
//
//  
#define MrakerPrefix "IO_"
#define SliderPrefix "SL_"
#define OP_CLOSE_BUY  678
#define OP_CLOSE_SELL 876
//
int init()   
{ 
  SetIndexBuffer(0,bBallance);
  IndicatorShortName("IndicatorOptimizer");
  
  return(0); 
}
int deinit() 
{ 
  ClearMarkers(); 
  ClearSliders();
  return(0); 
}

double ParamValue(int ParamNo, string ParamName, double ParamValue, double vMin, double vMax, color clr)
{
  double Triangle[3],vCur, WMax, WMin; datetime tt1, tt2; 

  //    -  
  if(ObjectFind(ParamName) < 0)
  {
    //        
    WMax = WindowPriceMax();  WMin = WindowPriceMin();

    //     ...
    tt1 = Time[0] + Period()*60*ParamNo*20; tt2 = tt1 + Period()*60*20;
    // ...  ""
    vCur = WMin + (ParamValue - vMin) * (WMax - WMin) / (vMax - vMin);
    //          
    ObjectCreate(ParamName,OBJ_TRIANGLE, 0, tt1,WMax, tt2,vCur, tt1,WMin);
    ObjectSet(ParamName,OBJPROP_COLOR,clr);
  }
  //   -   
  Triangle[0] = ObjectGet(ParamName,OBJPROP_PRICE1);
  Triangle[1] = ObjectGet(ParamName,OBJPROP_PRICE2);
  Triangle[2] = ObjectGet(ParamName,OBJPROP_PRICE3);
  //      "
  ArraySort(Triangle);
  //          vMin  vMax
  vCur = vMin + (Triangle[1] - Triangle[0]) / (Triangle[2] - Triangle[0]) * (vMax - vMin);
  //     
  ObjectSetText(ParamName,DoubleToStr(vCur,2)); 
  //     
  return(vCur); 
}


//
int start() 
{ 
  double Profit=0,P1,P2; int CntProfit=0,CntLoose=0,i1,i2;
  // -      
  double ToCurrency = MarketInfo(Symbol(),MODE_TICKVALUE)*LotForCalc;    
  
  //
  //        
  ClearMarkers(); 
  //
  //   
  sBuyCnt=0; sSellCnt=0; sBuyCloseCnt=0; sSellCloseCnt=0; 
  //
  //         
  DisplayBars=Bars; // -  
  ArrayResize(sBuy,DisplayBars);  ArrayInitialize(sBuy,0);
  ArrayResize(sSell,DisplayBars); ArrayInitialize(sSell,0);
  ArrayResize(sCloseBuy,DisplayBars);  ArrayInitialize(sCloseBuy,0);
  ArrayResize(sCloseSell,DisplayBars); ArrayInitialize(sCloseSell,0);

  //   
  ArrayInitialize(bBallance,0); 
  //


  //
  //  ( )     
  MAPeriod  = ParamValue(0, SliderPrefix+"MA Period", MAPeriod, 5, 35, Blue);
  RSIPeriod = ParamValue(1, SliderPrefix+"RSI Period", RSIPeriod, 2, 25, Red);
  RSILevel  = ParamValue(2, SliderPrefix+"RSI Level", RSILevel, 5, 95, Orange);
  //


  //        
  for(i=DisplayBars;i>=0;i--) 
  {
    double t1=iRSI(NULL,0,RSIPeriod,MAPrice,i+1);
    double t11=iRSI(NULL,0,RSIPeriod,MAPrice,i+2);

    double t2=iMA(NULL,0,MAPeriod,0,MAMode,MAPrice,i+1);

    double t3=iMA(NULL,0,MAPeriod*3,0,MAMode,MAPrice,i+1);

    if (t1>RSILevel&&t11<RSILevel&&t1>t11&&t1>RSILevel&&t2>t3) {sBuy[i]=1; sBuyCnt++;}
    if (t1<(100-RSILevel)&&t11>(100-RSILevel)&&t1<t11&&t1<(100-RSILevel)) {sCloseBuy[i]=1; sBuyCloseCnt++;}

    if (t1<(100-RSILevel)&&t11>(100-RSILevel)&&t1<t11&&t1<(100-RSILevel)&&t2<t3) {sSell[i]=1; sSellCnt++; } 
    if (t1>RSILevel&&t11<RSILevel&&t1>t11&&t1>RSILevel) {sCloseSell[i]=1; sSellCloseCnt++;}
  }

 
	//
  //        -   
  for(i=0;i<DisplayBars;i++) 
  {
    if(sBuy[i]==sBuy[i+1]) sBuy[i]=0;
    if(sSell[i]==sSell[i+1]) sSell[i]=0;
    if(sCloseBuy[i]==sCloseBuy[i+1]) sCloseBuy[i]=0;
    if(sCloseSell[i]==sCloseSell[i+1]) sCloseSell[i]=0;
  }
  //      
  for(i=0;i<DisplayBars;i++) 
  {
    if(Time[i]<DateStart || DateEnd<Time[i]) { sBuy[i]=0; sSell[i]=0; sCloseBuy[i]=0; sCloseSell[i]=0; }
  }
  //      
  if(DateEnd<=Time[0]) { i=iBarShift(Symbol(),Period(),DateEnd); sBuy[i]=0; sSell[i]=0; sCloseBuy[i]=1; sCloseSell[i]=1; }
  if(DateEnd >Time[0]) { sCloseBuy[0]=1; sCloseSell[0]=1; }
  //
  //   
  for(i=0;i<DisplayBars;i++) 
  {
    if(sBuy [i]!=0) sBuyCnt++;  if(sCloseBuy [i]!=0) sBuyCloseCnt++;
    if(sSell[i]!=0) sSellCnt++; if(sCloseSell[i]!=0) sSellCloseCnt++;
  }
  //
  //  ,     
  //
  //  
  for(i=DisplayBars-1;i>=0;i--) //   
  {
    //          
    for(i1=i;i1>=0;i1--) if(sBuy[i1]!=0) break; 

    //           
    for(i2=i1-1;i2>=0;i2--) if(sCloseBuy[i2]!=0) break;
    if(i2<0) i2=0; //         
    i=i2; //       

    //     
    P1=Open[i1]; P2=Open[i2];  
    
    P1/=Point; P2/=Point; //    
    
    //      
    if(i1>=0) 
    { 
      Profit=Profit+P2-P1; //   
      if(P2-P1>=0) CntProfit++; else CntLoose++; //   
      DrawLine(i1,i2,OP_BUY); //   
      PlaceMarker(i1,OP_BUY); 
      PlaceMarker(i2,OP_CLOSE_BUY); 
      
      bBallance[i2] += P2-P1;
    }
  }
  //
  //  
  for(i=DisplayBars-1;i>=0;i--) //   
  {
    //          
    for(i1=i;i1>=0;i1--) if(sSell[i1]!=0) break; 

    //           
    for(i2=i1-1;i2>=0;i2--) if(sCloseSell[i2]!=0) break;
    if(i2<0) i2=0; //         
    i=i2; //       

    //          Optimizm
    P1=Open[i1]; P2=Open[i2]; 
    
    P1/=Point; P2/=Point; //    
    
    //     -      
    if(i1>=0) 
    { 
      Profit=Profit+P1-P2; //   
      if(P1-P2>=0) CntProfit++; else CntLoose++; //   
      DrawLine(i1,i2,OP_SELL); //   
      PlaceMarker(i1,OP_SELL); 
      PlaceMarker(i2,OP_CLOSE_SELL);
      
      bBallance[i2] += P1-P2;
    }
  }

  //
  //   
  //      
  i2 = DisplayBars; bBallance[i2] = 0; 
  for(i=DisplayBars-1;i>=0;i--) { if(bBallance[i] != 0) { bBallance[i2] = bBallance[i2+1] + bBallance[i]; i2--;  } }
  double multiplier; if(ProfitInPoints) multiplier = 1; else multiplier = ToCurrency;
  for(i=0;i<DisplayBars-2;i++) bBallance[i] = bBallance[i+i2+1] * multiplier;
  SetIndexStyle(0,DRAW_HISTOGRAM,STYLE_SOLID,ProfitWidth,Blue);

  //
  //       
  int Cnt=CntProfit+CntLoose; //   
  string msg=": "+TimeToStr(MathMax(DateStart,Time[Bars-1]))+" - "+TimeToStr(MathMin(DateEnd,Time[0]))+"\n\n";
  
  msg=msg + 
  " RSI: " + RSIPeriod + "\n" +
  " RSI: " + RSILevel + "\n" +
  " : " + MAPeriod + "\n\n" +
  sBuyCnt+"   "+sBuyCloseCnt+"  \n"+
  sSellCnt+"   "+sSellCloseCnt+"  \n\n";
  
  //    
  int TotalDays = (MathMin(DateEnd,Time[0])-MathMax(DateStart,Time[Bars-1]))/60/60/24; //   
  if(TotalDays<=0) TotalDays=1; //         
  
  if(Cnt==0) msg=msg+("   ");
  else msg=msg+
  (
    DoubleToStr(Profit,0)+"   "+Cnt+"   "+TotalDays+" \n"+
    DoubleToStr(Profit/Cnt,1)+"    ("+
    DoubleToStr(Profit/TotalDays,1)+"  )\n\n"+
    "   "+DoubleToStr(LotForCalc,2)+"   "+AccountCurrency()+":\n"+
    DoubleToStr(Profit*ToCurrency,0)+" ,  "+
    DoubleToStr(Profit/Cnt*ToCurrency,1)+"   ("+
    DoubleToStr(Profit/TotalDays*ToCurrency,1)+"  )\n\n"+
    CntProfit+"  ("+DoubleToStr(((CntProfit)*1.0/Cnt*1.0)*100.0,1)+"%)\n"+
    CntLoose+"  ("+DoubleToStr(((CntLoose)*1.0/Cnt*1.0)*100.0,1)+"%)"
  );
  Comment(msg);
  
}
//



//
//     
void ClearMarkers() 
{ 
  for(int i=ObjectsTotal()-1;i>=0;i--) if(StringFind(ObjectName(i),MrakerPrefix)==0) ObjectDelete(ObjectName(i)); 
}
void ClearSliders() 
{ 
  for(int i=ObjectsTotal()-1;i>=0;i--) if(StringFind(ObjectName(i),SliderPrefix)==0) ObjectDelete(ObjectName(i)); 
}
//
//    -    op_type
void PlaceMarker(int i, int op_type)
{
  if(!ShowMARKERS) return; //   

  color MarkerColor; string MarkName; 

  // __          
  if(op_type==OP_CLOSE_SELL) { MarkerColor=ColorClose; MarkName=MrakerPrefix+"__SELL_"+i; }
  if(op_type==OP_CLOSE_BUY)  { MarkerColor=ColorClose; MarkName=MrakerPrefix+"__BUY_"+i;  }  
  if(op_type==OP_SELL)       { MarkerColor=ColorSell;  MarkName=MrakerPrefix+"_SELL_"+i;  }
  if(op_type==OP_BUY)        { MarkerColor=ColorBuy;   MarkName=MrakerPrefix+"_BUY_"+i;   }

  ObjectCreate(MarkName,OBJ_VLINE,0,Time[i],0); 
  ObjectSet(MarkName,OBJPROP_WIDTH,1); 
  if(op_type==OP_CLOSE_BUY || op_type==OP_CLOSE_SELL) ObjectSet(MarkName,OBJPROP_STYLE,STYLE_SOLID); 
  else ObjectSet(MarkName,OBJPROP_STYLE,STYLE_DOT);
  ObjectSet(MarkName,OBJPROP_BACK,True);  

  ObjectSet(MarkName,OBJPROP_COLOR,MarkerColor);
}
//
//        op_type    Optimizm
void DrawLine(int i1,int i2, int op_type)
{
  if(!ShowZZ) return; //   
  
  color urColor;
  string MarkName=MrakerPrefix+"_"+i1+"_"+i2;
  double P1,P2;
  
  //          Optimizm
  P1=Open[i1]; P2=Open[i2];  

  ObjectCreate(MarkName,OBJ_TREND,0,Time[i1],P1,Time[i2],P2);
  
  ObjectSet(MarkName,OBJPROP_RAY,False); //     
  ObjectSet(MarkName,OBJPROP_BACK,False);
  ObjectSet(MarkName,OBJPROP_STYLE,STYLE_SOLID);
  ObjectSet(MarkName,OBJPROP_WIDTH,2);

  //        
  if(op_type==OP_BUY) 
  { 
    if(P1 <P2) urColor = ColorProfitBuy;
    if(P1==P2) urColor = ColorZeroBuy;
    if(P1 >P2) urColor = ColorLossBuy;
  }
  if(op_type==OP_SELL) 
  { 
    if(P1 >P2) urColor = ColorProfitSell;
    if(P1==P2) urColor = ColorZeroSell;
    if(P1 <P2) urColor = ColorLossSell;
  }
  ObjectSet(MarkName,OBJPROP_COLOR,urColor);
}
//

